// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNManager.hpp"
#include "games/vn/events/VNEvent.hpp"

using namespace Dawn;

VNManager::VNManager(SceneItem *item) :
  SceneItemComponent(item)
{
}

void VNManager::onStart() {
  if(this->currentEvent != nullptr) {
    this->currentEvent->start(nullptr);
  }
}

void VNManager::setEvent(VNEvent *event) {
  this->currentEvent = event;
}

void VNManager::nextEvent() {
  if(this->currentEvent == nullptr) return;
  auto old = this->currentEvent;
  old->end();
  this->currentEvent = old->getNextEvent();
  if(this->currentEvent != nullptr) this->currentEvent->start(old);
}

void VNManager::onDispose() {
  
}