// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNEvent.hpp"

using namespace Dawn;

void VNEvent::init(VNManager *manager) {
  this->manager = manager;
}

void VNEvent::start(VNEvent *previous) {
  this->onStart();
}

Scene * VNEvent::getScene() {
  return this->manager->getScene();
}

VNEvent * VNEvent::getNextEvent() {
  return this->doNext;
}

void VNEvent::next() {
  assertNotNull(this->manager);
  assertTrue(this->manager->currentEvent == this);
  this->manager->nextEvent();
}

void VNEvent::end() {
  this->unsubscribeAllEvents();
  this->onEnd();
}

void VNEvent::onStart() {}
void VNEvent::onEnd() {}